# This file is automatically generated by the rmf-codegen project.
#
# The Python code generator is maintained by Lab Digital. If you want to
# contribute to this project then please do not edit this file directly
# but send a pull request to the Lab Digital fork of rmf-codegen at
# https://github.com/labd/rmf-codegen
import typing
import warnings

from ...models.common import Error, PageDataResponse, RedirectResponse

if typing.TYPE_CHECKING:
    from ...base_client import BaseClient


class FrontasticPageRequestBuilder:
    _client: "BaseClient"

    def __init__(
        self,
        client: "BaseClient",
    ):
        self._client = client

    def get(
        self,
        *,
        headers: typing.Dict[str, str] = None,
        options: typing.Dict[str, typing.Any] = None,
    ) -> "PageDataResponse":
        """Returns the structure and data of the published page displayed from commercetools Frontend. \
        
        Headers&#58;
        
        - `Frontastic-Path` - `^/.*$` - Required
        - `Accept` - `application/json` - Required
        - `Frontastic-Locale` - [Locale](ctp:frontend-api:type:Locale) - Required
        
        """
        headers = {} if headers is None else headers
        response = self._client._get(
            endpoint=f"/frontastic/page", params={}, headers=headers, options=options
        )
        if response.status_code == 200:
            return PageDataResponse.deserialize(response.json())
        elif response.status_code == 301:
            obj = RedirectResponse.deserialize(response.json())
            raise self._client._create_exception(obj, response)
        elif response.status_code == 404:
            obj = Error.deserialize(response.json())
            raise self._client._create_exception(obj, response)
        warnings.warn("Unhandled status code %d" % response.status_code)
