# This file is automatically generated by the rmf-codegen project.
#
# The Python code generator is maintained by Lab Digital. If you want to
# contribute to this project then please do not edit this file directly
# but send a pull request to the Lab Digital fork of rmf-codegen at
# https://github.com/labd/rmf-codegen
import typing
import warnings

from ...models.common import Error, PagePreviewDataResponse

if typing.TYPE_CHECKING:
    from ...base_client import BaseClient


class FrontasticPreviewRequestBuilder:
    _client: "BaseClient"

    def __init__(
        self,
        client: "BaseClient",
    ):
        self._client = client

    def get(
        self,
        *,
        locale: str,
        preview_id: str,
        headers: typing.Dict[str, str] = None,
        options: typing.Dict[str, typing.Any] = None,
    ) -> "PagePreviewDataResponse":
        """Returns the page structure and data for a specific [preview](/../frontend-studio/previewing-page-versions#accessing-page-version-preview) by its `previewId`. \
        
        Headers&#58;
        
        - `Accept` - `application/json` - Required
        
        """
        headers = {} if headers is None else headers
        response = self._client._get(
            endpoint=f"/frontastic/preview",
            params={"locale": locale, "previewId": preview_id},
            headers=headers,
            options=options,
        )
        if response.status_code == 200:
            return PagePreviewDataResponse.deserialize(response.json())
        elif response.status_code == 404:
            obj = Error.deserialize(response.json())
            raise self._client._create_exception(obj, response)
        warnings.warn("Unhandled status code %d" % response.status_code)
